OCOBOL >>SOURCE FORMAT IS FIXED
      *> *******************************************************
      *> Author:    Brian Tiffin
      *> Date:      20130326
      *> Purpose:   cbrain
      *> Tectonics: cobc -x callcbrain.cob cbrain.c
      *> *******************************************************
       identification division.
       program-id. callcbrain.
       
       environment division.
       configuration section.
       SPECIAL-NAMES.
       ALPHABET ALPHA IS NATIVE.
       ALPHABET BETA IS EBCDIC.

       data division.
       working-storage section.
       01 cbrain-cmd           pic x(132).
       01 string-cell          pic z(19)9.
       01 fielded-variable     pic xxx.
       01 cell                 pic s9(8).
       01 looper               pic s9(8).
       01 brain-cells.
          05 brain-cell usage binary-c-long occurs 65536 times.
       01 variable             pic x(32).
      *> *******************************************************
       procedure division.
      *call "cbrain" using brain-cells
      *    by content "file hoc.cb" & x"00"
      *end-call

       initialize brain-cells       
       call "cbrain" using brain-cells
           by content "file bitwise.cb" & x"00"
           returning cell
       end-call
       display "OC: from bitwise.cb " brain-cell(cell) end-display

       move "127>85^" &x"00" to variable
       INSPECT variable CONVERTING ALPHA TO BETA
       call "CBL_OC_DUMP" using variable, 32 end-call

       display "OC: EBCDIC is " variable end-display

       call "cbrain" using brain-cells
           by content "127 > 85 ^" & x"00"
           returning cell
       end-call
       display "OC: from expression " brain-cell(cell) end-display

       call "cbrain" using brain-cells
           "{127 xor 85}" &
           "{define procedure 1 for newline}" &
           "0+(> 10 . <)" &
           "{place 127 in memory 0," &
           "  place 85 in memory 1," &
           "  bitwise XOR," &
           "  display as number." &
           "  Then, call procedure 1 for a newline," &
           "  advancing and retreating}" &
           "127" &
           "> 85 ^ #" &
           "> 1 : <" & x"00"
           returning cell
       end-call
       display "OC: 127 xor 85 = " brain-cell(cell) end-display

       initialize brain-cells       
       call "cbrain" using brain-cells
           by content "file morehello.cb" & x"00"
           returning cell
           on exception continue
       end-call

       initialize brain-cells       
       call "cbrain" using brain-cells
           by content "file pbrains.cb" & x"00"
           returning cell
           on exception continue
       end-call

      *> this is why bitwise might actually get written someday
       move 123 to fielded-variable
       initialize brain-cells
       call "cbrain" using brain-cells
           by content function concatenate(
               fielded-variable 
               "> 31 &", x"00")
           returning cell
       end-call
       display "OC: fielded-variable " fielded-variable " and 31 is "
           brain-cell(cell)
       end-display 

       perform varying looper from 1 by 1 until looper > 5
           move looper to string-cell
           string
               string-cell delimited by size
               " > 91 a #  > 38 . 32 . <  > 31 # &  > 61 . 32 . < # b" &
               " > 10 . <"  delimited by size
               x"00" delimited by size
               into cbrain-cmd
               on overflow
                   display "too much brain" end-display
           end-string

           initialize brain-cells
           call "cbrain" using brain-cells
               by content cbrain-cmd
               returning cell
               on exception continue
           end-call
      *    display "OC: " brain-cell(cell) end-display
       end-perform
       
       goback.
       end program callcbrain.

