       >>SOURCE FORMAT IS FREE
      *> ***************************************************************
      *> Author:    Brian Tiffin
      *> Date:      20130402 
      *> Purpose:   cobrain Read Eval Loop
      *> Tectonics: cobc -x cobrainrun.cob subcranial.cob cobrain.c -lreadline
      *> ***************************************************************
       identification division.
       program-id. cogb.

       environment division.
       configuration section.
       repository.
           function all intrinsic.

       data division.
       working-storage section.
       01 args                 pic x(256).
       01 linepointer          usage pointer.
       01 line-buffer          pic x(2048)       based.
       01 source-tape          pic x(2048).
       01 source-line          pic x(2048).
       01 brain-cells.
          05 brain-cell usage binary-c-long occurs 65536 times.
       01 cell                 pic s9(8).
          88 brain-freeze         value -1.

      *> ***************************************************************
       procedure division.
       call "using_history"
           on exception continue 
    >>D    display "cobrainrun readline history recall error" end-display
       end-call

       accept args from command-line end-accept
       if args not equal spaces then
           call "cogbrain" using 
               concatenate("file " trim(args))
               returning cell
               on exception display "call to cogbrain failure" end-display
           end-call
       end-if
       if brain-freeze then goback end-if

       display "Welcome to cogbrain v0.21" end-display
       move spaces to source-tape
       perform until brain-freeze
           move spaces to source-line
           call "readline" using by content "co: "
               returning linepointer
               on exception
                   display "co: " with no advancing end-display
                   accept source-line end-accept
               not on exception
                   if linepointer is equal to null then
                       exit perform
                   end-if
                   set address of line-buffer to linepointer
                   string line-buffer delimited by null
                       into source-line
                   end-string
                   if source-line not equal spaces then
                       call "add_history"
                           using by value linepointer
                           on exception continue
                       end-call
                   end-if

                   call "free" using
                       by value linepointer
                       on exception continue
                   end-call
           end-call
                   
           if source-line equal spaces then exit perform end-if
           move function concatenate(
                function trim(source-tape),
                function trim(source-line))
             to source-tape

           call "cogbrain" using source-line
               returning cell
               on exception display "call to cobrain failure" end-display
           end-call
       
       end-perform       
       display "bye" end-display

       goback.
       end program cogb.
