OCOBOL >>SOURCE FORMAT IS FREE
      *> ********************************************************
      *> Author:    Brian Tiffin
      *> Date:      20130331
      *> Purpose:   submodule for cobrain
      *> Tectonics: cobc -x cobrainrun.cob subcranial.cob cobrain.c -lreadline
      *>            cb: 23 # "subcranial" #
      *> ********************************************************
       identification division.
       program-id. subcranial.
       data division.
       linkage section.
       01 brain-cell usage binary-long.

      *> ********************************************************
       procedure division using by value brain-cell.
       move 42 to return-code
    >>D display
    >>D     "OC: got " brain-cell " returning " return-code
    >>D end-display
       goback.
       end program subcranial.
      *> ********************************************************
       
      *> ********************************************************
       identification division.
       program-id. cobrainhelp.

       environment division.
       configuration section.
       repository.
           function all intrinsic.

       data division.
       working-storage section.
       01 jars                 value "012345678901234567890".
          03 flies.
             05 fly            pic 9 occurs 21 times.
       linkage section.
       01 brain-cell usage binary-long.

      *> ********************************************************
       procedure division using by value brain-cell.
       evaluate brain-cell
           when 1028 
               display "10-28 received, cobrain v0.21, Apr 2013, expect 42" end-display
               display "Daniel B Cristofani posted pbrain.c, modified for cbrain and then cobrian by Brian Tiffin" end-display
               display "Tectonics:" &x"0a" "    cobc -x cobrainmain.c subcranial.cob -lreadline -g -debug -fdebugging-line" end-display
               display "    cobc -x cobrainrun.cob subcranial.cob cobrain.c -lreadline" end-display
               move 42 to return-code
               goback
           when 1036  
               display locale-date(current-date(1:8)) " " locale-time(current-date(9:6)) end-display
               move 42 to return-code
               goback
           when 1094
               call "frogsort" using flies end-call
           when other
               display "cobrainhelp received " brain-cell " and will stop run"  end-display
       end-evaluate

       display x"0a" & "===From bf===" end-display
       display "p, increment current cell" end-display
       display "m, decrement current cell" end-display
       display ">, advance data cell index up 1" end-display
       display "<, retreat data cell index down 1" end-display
       display "[, if current cell zero, skip source index forward to next ]" end-display
       display "], if current cell non-zero, skip source index backwards to previous [" end-display
       display "., output current cell" end-display
       display ",, accept key value to current cell" end-display

       display x"0a" & "===cobrain adds===" end-display
       display "digits, 0 though 9, if last operation was digit, scale current cell up by 10 and add in, otherwise zero out and add in digit" end-display
       display "_, negate current" end-display
       display "(, enter block on true (non zero), till nested close marker )" end-display
       display "{, enter block on false (zero), till nested close marker }" end-display
       display "+, add current cell into previous cell and retreat" end-display
       display "-, subtract current cell from previous cell and retreat" end-display
       display "*, multiply current cell by previous cell into previous cell and retreat" end-display
       display "/, divide previous cell by current cell leaving quotient in previous and remainder in current, no retreat" end-display
       display "^, bitwise xor current cell with previous cell and retreat" end-display
       display "&, bitwise and current cell with previous cell and retreat" end-display
       display "|, bitwise or current cell with previous cell and retreat" end-display
       display "~, bitwise not of current cell into current cell" end-display
       display "r, right shift previous cell by current cell bits and retreat" end-display
       display "l, left shift previous cell by current cell bits and retreat" end-display
       display "%, compute modulus of previous cell by current cell into previous cell and retreat" end-display
       display "@, fetch current cell value and place in memory register" end-display
       display "$, address of current to memory register" end-display
       display "`, dereference current into current" end-display
       display "c, compare current cell value to zero and place sign in current" end-display
       display "!, store content of memory register in current cell" end-display
       display "s, swap current cell with previous" end-display
       display "o, copy previous cell over to next and advance" end-display
       display "d, duplicate current cell to next cell and advance" end-display
       display "n, output current cell as integer" end-display
       display "#, output current cell as formatted integer" end-display
       display "b, output current cell as base 2" end-display
       display "=, input integer and place value in current cell" end-display
       display "', scan forward to ', call that COBOL module, passing frame based on current, replacing frame with RETURN-CODE" end-display
       display "?, display memory up to current" end-display
       display "t, toggle step trace" end-display
       display "g, goback" end-display
       display "q, quit" end-display
       display "reserved word 'help'" ', calls "cbrainhelp", the OpenCOBOL module using cbrain quoted string.' end-display
       display "reserved word 'file ' loads script using rest of source text as filename." end-display
       move 42 to return-code
       goback.
       end program cobrainhelp.
      *> ********************************************************

      *> ********************************************************
      *>  frogSort, called for help with 10-94, request for count
      *> ********************************************************
       identification division.
       program-id. frogsort.
       data division.
       working-storage section.
       01 opinion          usage binary-long.
       01 shared-value     pic 99.
          88 fair          value 1.
       01 caveman-count    pic x(12) value "[-]+++++++++".
       01 spacer           pic x(10) value spaces.

       linkage section.
       01 jars.
          05 flies        pic 9 occurs 21 times.

      *> ********************************************************
       procedure division using jars.
       start-here.
       move function length(jars) to shared-value
       display "Grog sort jars.  frogSort" end-display
       display "http://www.smbc-comics.com/?id=2831" end-display
       .

       forkyourself.
           call "fork" returning opinion end-call
           if opinion is zero then
               subtract 1 from shared-value
               if not fair then go forkyourself.
       .
 
       call "sleep" using by value flies(shared-value) end-call
       display
           "Jar: " function char(shared-value + 65) " reporting "
           caveman-count(1 : flies(shared-value) + 3) " flies,"
           spacer(1 : 10 - flies(shared-value))
           "that would be " flies(shared-value) " to you, futureman."
       end-display
       call "wait" using by value 0 end-call

       stop run returning 107.
       end program frogsort.
